/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is
 * Tim Taubert <tim@timtaubert.de>
 * Portions created by the Initial Developer are Copyright (C) 2011
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

let {Windows} = require("util/windows");

let Actions = {
  _labels: {
    "focusURLBar": "Fokus in das Adressfeld setzen",
    "focusURLBar2": "Fokus in das Adressfeld setzen",
    "key_search2": "Web-Suche",
    "key_stop": "Stopp",
    "goBackKb": "Eine Seite zurück",
    "goBackKb2": "Eine Seite zurück",
    "goForwardKb": "Eine Seite vor",
    "goForwardKb2": "Eine Seite zurück",
    "key_close": "Tab schließen",
    "key_undoCloseTab": "Geschlossenen Tab wiederherstellen",
    "key_undoCloseWindow": "Geschlossenes Fenster wiederherstellen",
    "key_toggleAddonBar": "Add-on-Bar umschalten",
    "key_findPrevious": "Aufwärts suchen",
    "key_selectLastTab": "Letzten Tab auswählen",
    "key_selectTab1": "Tab 1 auswählen",
    "key_selectTab2": "Tab 2 auswählen",
    "key_selectTab3": "Tab 3 auswählen",
    "key_selectTab4": "Tab 4 auswählen",
    "key_selectTab5": "Tab 5 auswählen",
    "key_selectTab6": "Tab 6 auswählen",
    "key_selectTab7": "Tab 7 auswählen",
    "key_selectTab8": "Tab 8 auswählen",
    "key_tabview": "Tab-Gruppen",
    "key_nextTabGroup": "Zur nächsten Tab-Gruppe wechseln",
    "key_previousTabGroup": "Zur vorherigen Tab-Gruppe wechseln",
    "viewBookmarksSidebarWinKb": "Lesezeichen in der Sidebar anzeigen"
  },

  get menuItems() {
    if (!this._menuItems)
      this._loadMenuItems();

    return this._menuItems;
  },

  findByKey: function (key) {
    let label = key.getLabel();

    if (label)
      return label;

    let id = key.id;

    if (id in this._labels)
      return this._labels[id];

    // try to find a menuitem
    let menuitem = Windows.querySelector("menuitem[key=" + id + "]");
    if (menuitem && menuitem.hasAttribute("label"))
      return menuitem.getAttribute("label");

    return id;
  }
}

exports.Actions = Actions;
